/*=========================================================================
 * This file is part of TouchWidgets, which is a widget library that
 * supports touch and animation.
 *
 * Copyright (C) 2004,2008-2010,2013 Zachary Smith, veritas@comcast.net.
 *
 * TouchWidgets is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * TouchWidgets is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with TouchWidgets.  If not, see <http://www.gnu.org/licenses/>.
 *=======================================================================*/

#ifndef _TOUCHWIDGETS_ALERT_H
#define _TOUCHWIDGETS_ALERT_H

#include <TouchWidgets/Controller.h>
#include <TouchWidgets/Button.h>
#include <TouchWidgets/Label.h>

using namespace TouchWidgets;

class Alert : public Controller
{
	const char *message;
	Button *button1;
	Button *button2;
	Label *label;

	Size button_size;

	void create_widgets (void);

public:
	Alert (const char *);
	Alert ();
	~Alert ();

	void show ();

        virtual const char* class_name () { return "Alert"; }

	void layout_widgets (void);

	void will_appear (void);
	void will_disappear (void);
	void did_appear (void);
	void did_disappear (void);

	void receive_message(Object*, const char*, MessageParameter); // Inherited from Object.
};

#endif
