/*=========================================================================
 * This file is part of TouchWidgets, which is a widget library that
 * supports touch and animation.
 *
 * Copyright (C) 2004,2008-2010,2013 Zachary Smith, veritas@comcast.net.
 *
 * TouchWidgets is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * TouchWidgets is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with TouchWidgets.  If not, see <http://www.gnu.org/licenses/>.
 *=======================================================================*/

#ifndef _TOUCHWIDGETS_BUTTONBAR_H
#define _TOUCHWIDGETS_BUTTONBAR_H

#include <TouchWidgets/Widget.h>

namespace TouchWidgets {

#define MAX_BARBUTTONS (10)
#define DEFAULT_BUTTONBAR_BORDER (4)
#define DEFAULT_BUTTONBAR_BGCOLOR (0x4060c0)
#define DEFAULT_BUTTONBAR_FGCOLOR (0xf0f8ff)

class ButtonBar : public Widget
{
// NOTE: There's a practical limit to how many buttons will fit inside the ButtonBar in one row.
	int n_buttons;
	int selection;
	char *strings [MAX_BARBUTTONS]; 
	bool tap_down;

public:
        virtual const char* class_name () { return "ButtonBar"; }

	void draw (Rect);

	void select (int);
	void deselect (void);

	ButtonBar (void);
	virtual ~ButtonBar (void);

	void add_button (const char *);

        void receive_message (Object *sender, Message, MessageParameter tmp);
};

}

#endif

