/*=========================================================================
 * This file is part of TouchWidgets, which is a widget library that
 * supports touch and animation.
 *
 * Copyright (C) 2004,2008-2010,2013 Zachary Smith, veritas@comcast.net.
 *
 * TouchWidgets is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * TouchWidgets is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with TouchWidgets.  If not, see <http://www.gnu.org/licenses/>.
 *=======================================================================*/

#ifndef _TOUCHWIDGETS_CANVAS_H
#define _TOUCHWIDGETS_CANVAS_H

extern "C" {
#include <stdint.h>
#include <stdlib.h>
}

#include <TouchWidgets/Widget.h>

namespace TouchWidgets {

class Canvas : public Widget
{
        int image_height;
        int image_width;
        unsigned image_ncomponents;
        uint8_t *pixels;
        XImage *ximage;

	void allocate_pixels (void);

	void draw_hline (int x, int y, int width, RGB color);
	//void draw_vline (int x, int y, int width, RGB color);

public:
        virtual const char* class_name () { return "Canvas"; }

	virtual void draw (Rect);

	Canvas (void);
	~Canvas (void);
	Canvas (Size, RGB);

	void setup (int w, int h, RGB);

	void clear (void);
	RGB get_pixel (Point);
	void put_pixel (Point, RGB);
	void draw_line (Point, Point, RGB);
	void draw_rect (Rect, RGB);
	void fill_rect (Rect, RGB);
};

}

#endif

