/*=========================================================================
 * This file is part of TouchTest, which is a demonstration of TouchWidgets.
 *
 * Copyright (C) 2013 Zachary Smith, veritas@comcast.net.
 *
 * TouchTest is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published
 * by the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * TouchTest is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with TouchTest.  If not, see <http://www.gnu.org/licenses/>.
 *=======================================================================*/

#include <TouchWidgets/Controller.h>
#include <TouchWidgets/Button.h>
#include <TouchWidgets/Container.h>
#include <TouchWidgets/Scroll.h>
#include <TouchWidgets/Label.h>
#include <TouchWidgets/ImageView.h>
#include <TouchWidgets/App.h>
#include <TouchWidgets/VerticalList.h>
#include <TouchWidgets/Progress.h>
#include <TouchWidgets/TextField.h>
#include <TouchWidgets/Grid.h>
#include <TouchWidgets/Graph.h>
#include <TouchWidgets/Canvas.h>
#include <TouchWidgets/Alert.h>
#include <TouchWidgets/Keyboard.h>

using namespace TouchWidgets;

class ExampleController : public Controller
{
	Button *button1;
	Button *button2;

	Progress *progress1;

	Container *container;
	Button *button3;
	Button *button4;
	
	Scroll *scroll;
	Button *b1;
	Button *b2;
	Button *b3;
	Button *b4;
	Label *l1;
	Label *l2;
	Label *l3;

	TextField *textfield;

	VerticalList *vlc;

	ImageView *img1;

	Grid *grid;
	Label *l10;
	Label *l11;
	Label *l12;
	Label *l13;
	Label *l14;
	Label *l15;
	Label *l16;
	Button *b17;

	Graph *graph1;
	Graph *graph2;
	Graph *graph3;

	Canvas *canvas;

	Alert *alert;
	Keyboard *keyboard;

	void draw_in_canvas();

public:
	ExampleController ();

        virtual const char* class_name () { return "ExampleController"; }

	void layout_widgets (void);

	void will_appear (void);
	void will_disappear (void);
	void did_appear (void);
	void did_disappear (void);

	void receive_message(Object*, const char*, MessageParameter); // Inherited from Object.
};

