/*=========================================================================
 * This file is part of TouchWidgets, which is a widget library that
 * supports touch and animation.
 *
 * Copyright (C) 2004,2008-2010,2013 Zachary Smith, veritas@comcast.net.
 *
 * TouchWidgets is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * TouchWidgets is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with TouchWidgets.  If not, see <http://www.gnu.org/licenses/>.
 *=======================================================================*/

#ifndef _TOUCHWIDGETS_GRAPH_H
#define _TOUCHWIDGETS_GRAPH_H

// *** CAVEAT *** CAVEAT *** *** CAVEAT *** CAVEAT ***
//
// This is only a very simple graphing class at this point.
// It does not handle negative values.
// It does draw any text, nor any tick marks.
//
// *** CAVEAT *** CAVEAT *** *** CAVEAT *** CAVEAT ***

#include <vector>

#include <TouchWidgets/Widget.h>

namespace TouchWidgets {

enum {
	GRAPH_MODE_BAR=1,
	GRAPH_MODE_LINE=2,
	GRAPH_MODE_SCATTER=3,
};

class Graph : public Widget
{
        std::vector<float> xvalues; 
        std::vector<float> yvalues; 
        std::vector<RGB> colors; 

	float max_x;
	float min_x;
	float max_y;
	float min_y;

	int mode;
	Margins margins;
#if 0
	const char *x_units;
	const char *y_units;
#endif

	void draw_bar_graph (GC);
	void draw_line_graph (GC);
	void draw_scatter_plot (GC);

public:
	RGB color;

	void draw (Rect);

	void set_mode (int m) { mode = m; if (window) redraw (); }
	void set_margin (Margins m) { margins = m; if (window) redraw (); }

	Graph (void);
	~Graph ();
        virtual const char* class_name () { return "Graph"; }

	void add_value (float); // y value, x = 0.
	void add_point (Point);
	void clear_data (void);
	void determine_min_max (void);
};

}

#endif

