/*=========================================================================
 * This file is part of TouchWidgets, which is a widget library that
 * supports touch and animation.
 *
 * Copyright (C) 2004,2008-2010,2013 Zachary Smith, veritas@comcast.net.
 *
 * TouchWidgets is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * TouchWidgets is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with TouchWidgets.  If not, see <http://www.gnu.org/licenses/>.
 *=======================================================================*/

#ifndef _TOUCHWIDGETS_GRID_CONTAINER_H
#define _TOUCHWIDGETS_GRID_CONTAINER_H

#include <TouchWidgets/Scroll.h>

namespace TouchWidgets {

class Grid : public Scroll
{
protected:
	int n_columns, n_rows;
	int n_pages;
	bool show_separators;
	Dimension padding;

	void reposition_children (void);

public:
	Grid (void);
	~Grid (void);

        void draw (Rect);

	void child_was_tapped (int);

        virtual const char* class_name () { return "Grid"; }
};

}

#endif

