/*=========================================================================
 * This file is part of TouchWidgets, which is a widget library that
 * supports touch and animation.
 *
 * Copyright (C) 2004,2008-2010,2013 Zachary Smith, veritas@comcast.net.
 *
 * TouchWidgets is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * TouchWidgets is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with TouchWidgets.  If not, see <http://www.gnu.org/licenses/>.
 *=======================================================================*/

#ifndef _TOUCHWIDGTES_IMAGEVIEW_H
#define _TOUCHWIDGTES_IMAGEVIEW_H

#include <TouchWidgets/Widget.h>

extern "C" {
#include <stdlib.h>
#include <jpeglib.h>
#include <X11/ImUtil.h>
};

namespace TouchWidgets {

class ImageView : public Widget
{
	char mode;
	char *pixels;
	unsigned image_width;
	unsigned image_height;
	unsigned image_ncomponents;
	XImage *ximage;

	void allocate_pixels (void);
	char read_jpeg_file (char *path);
	int save_jpeg_scanline (JSAMPLE* data, int nbytes);

public:
	ImageView (void);
	ImageView (Size size, RGB image_bg);
	ImageView (char *path, RGB image_bg);
	~ImageView (void);

        virtual const char* class_name () { return "ImageView"; }

	void set_mode (int m) { mode = m; redraw (); }

	void draw (Rect);
};

}

#endif

