/*=========================================================================
 * This file is part of TouchWidgets, which is a widget library that
 * supports touch and animation.
 *
 * Copyright (C) 2004,2008-2010,2013 Zachary Smith, veritas@comcast.net.
 *
 * TouchWidgets is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * TouchWidgets is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with TouchWidgets.  If not, see <http://www.gnu.org/licenses/>.
 *=======================================================================*/


#include <TouchWidgets/App.h>

#include "Keyboard.h"

using namespace TouchWidgets;

void
Keyboard::create_widgets (void)
{
	if (key_a)
		return;

	root_widget = new Widget ();
	key_a = new Button ("A");
	key_b = new Button ("B");
	key_c = new Button ("C");
	key_d = new Button ("D");
	key_e = new Button ("E");
	key_f = new Button ("F");
	key_g = new Button ("G");
	key_h = new Button ("H");
	key_i = new Button ("I");
	key_j = new Button ("J");
	key_k = new Button ("K");
	key_l = new Button ("L");
	key_m = new Button ("M");
	key_n = new Button ("N");
	key_o = new Button ("O");
	key_p = new Button ("P");
	key_q = new Button ("Q");
	key_r = new Button ("R");
	key_s = new Button ("S");
	key_t = new Button ("T");
	key_u = new Button ("U");
	key_v = new Button ("V");
	key_w = new Button ("W");
	key_x = new Button ("X");
	key_y = new Button ("Y");
	key_z = new Button ("Z");
	key_space = new Button ("Space");
	key_1 = new Button ("!\n1");
	key_2 = new Button ("@\n2");
	key_3 = new Button ("#\n3");
	key_4 = new Button ("$\n4");
	key_5 = new Button ("%\n5");
	key_6 = new Button ("^\n6");
	key_7 = new Button ("&\n7");
	key_8 = new Button ("*\n8");
	key_9 = new Button ("(\n9");
	key_0 = new Button (")\n0");
	key_minus = new Button ("_\n-");
	key_equals = new Button ("+\n=");
	key_delete = new Button ("Delete");
	key_backquote = new Button ("~\n`");
	key_shift1 = new Button ("Shift");
	key_shift2 = new Button ("Shift");
	key_control1 = new Button ("Control");
	key_control2 = new Button ("Control");
	key_tab = new Button ("Tab");
	key_escape = new Button ("Esc");
	key_enter = new Button ("Enter");
	key_period = new Button (">\n.");
	key_comma = new Button ("<\n,");
	key_slash = new Button ("?\n/");
	key_leftbracket = new Button ("{\n[");
	key_rightbracket = new Button ("}\n]");
	key_backslash = new Button ("|\n\\");
	key_semicolon = new Button (":\n;");
	key_quote = new Button ("\"\n'");

	root_widget->add_child (key_a);
	root_widget->add_child (key_b);
	root_widget->add_child (key_c);
	root_widget->add_child (key_d);
	root_widget->add_child (key_e);
	root_widget->add_child (key_f);
	root_widget->add_child (key_g);
	root_widget->add_child (key_h);
	root_widget->add_child (key_i);
	root_widget->add_child (key_j);
	root_widget->add_child (key_k);
	root_widget->add_child (key_l);
	root_widget->add_child (key_m);
	root_widget->add_child (key_n);
	root_widget->add_child (key_o);
	root_widget->add_child (key_p);
	root_widget->add_child (key_q);
	root_widget->add_child (key_r);
	root_widget->add_child (key_s);
	root_widget->add_child (key_t);
	root_widget->add_child (key_u);
	root_widget->add_child (key_v);
	root_widget->add_child (key_w);
	root_widget->add_child (key_x);
	root_widget->add_child (key_y);
	root_widget->add_child (key_z);
	root_widget->add_child (key_space);
	root_widget->add_child (key_1);
	root_widget->add_child (key_2);
	root_widget->add_child (key_3);
	root_widget->add_child (key_4);
	root_widget->add_child (key_5);
	root_widget->add_child (key_6);
	root_widget->add_child (key_7);
	root_widget->add_child (key_8);
	root_widget->add_child (key_9);
	root_widget->add_child (key_0);
	root_widget->add_child (key_minus);
	root_widget->add_child (key_equals);
	root_widget->add_child (key_delete);
	root_widget->add_child (key_backquote);
	root_widget->add_child (key_shift1);
	root_widget->add_child (key_shift2);
	root_widget->add_child (key_control1);
	root_widget->add_child (key_control2);
	root_widget->add_child (key_tab);
	root_widget->add_child (key_escape);
	root_widget->add_child (key_enter);
	root_widget->add_child (key_period);
	root_widget->add_child (key_comma);
	root_widget->add_child (key_slash);
	root_widget->add_child (key_leftbracket);
	root_widget->add_child (key_rightbracket);
	root_widget->add_child (key_backslash);
	root_widget->add_child (key_semicolon);
	root_widget->add_child (key_quote);

	key_a->set_delegate (this);
	key_b->set_delegate (this);
	key_c->set_delegate (this);
	key_d->set_delegate (this);
	key_e->set_delegate (this);
	key_f->set_delegate (this);
	key_g->set_delegate (this);
	key_h->set_delegate (this);
	key_i->set_delegate (this);
	key_j->set_delegate (this);
	key_k->set_delegate (this);
	key_l->set_delegate (this);
	key_m->set_delegate (this);
	key_n->set_delegate (this);
	key_o->set_delegate (this);
	key_p->set_delegate (this);
	key_q->set_delegate (this);
	key_r->set_delegate (this);
	key_s->set_delegate (this);
	key_t->set_delegate (this);
	key_u->set_delegate (this);
	key_v->set_delegate (this);
	key_w->set_delegate (this);
	key_x->set_delegate (this);
	key_y->set_delegate (this);
	key_z->set_delegate (this);
	key_space->set_delegate (this);
	key_1->set_delegate (this);
	key_2->set_delegate (this);
	key_3->set_delegate (this);
	key_4->set_delegate (this);
	key_5->set_delegate (this);
	key_6->set_delegate (this);
	key_7->set_delegate (this);
	key_8->set_delegate (this);
	key_9->set_delegate (this);
	key_0->set_delegate (this);
	key_minus->set_delegate (this);
	key_equals->set_delegate (this);
	key_delete->set_delegate (this);
	key_backquote->set_delegate (this);
	key_shift1->set_delegate (this);
	key_shift2->set_delegate (this);
	key_control1->set_delegate (this);
	key_control2->set_delegate (this);
	key_tab->set_delegate (this);
	key_escape->set_delegate (this);
	key_enter->set_delegate (this);
	key_period->set_delegate (this);
	key_comma->set_delegate (this);
	key_slash->set_delegate (this);
	key_leftbracket->set_delegate (this);
	key_rightbracket->set_delegate (this);
	key_backslash->set_delegate (this);
	key_semicolon->set_delegate (this);
	key_quote->set_delegate (this);

	key_a->use_bold_font ();
	key_b->use_bold_font ();
	key_c->use_bold_font ();
	key_d->use_bold_font ();
	key_e->use_bold_font ();
	key_f->use_bold_font ();
	key_g->use_bold_font ();
	key_h->use_bold_font ();
	key_i->use_bold_font ();
	key_j->use_bold_font ();
	key_k->use_bold_font ();
	key_l->use_bold_font ();
	key_m->use_bold_font ();
	key_n->use_bold_font ();
	key_o->use_bold_font ();
	key_p->use_bold_font ();
	key_q->use_bold_font ();
	key_r->use_bold_font ();
	key_s->use_bold_font ();
	key_t->use_bold_font ();
	key_u->use_bold_font ();
	key_v->use_bold_font ();
	key_w->use_bold_font ();
	key_x->use_bold_font ();
	key_y->use_bold_font ();
	key_z->use_bold_font ();
	key_space->use_bold_font ();
	key_1->use_bold_font ();
	key_2->use_bold_font ();
	key_3->use_bold_font ();
	key_4->use_bold_font ();
	key_5->use_bold_font ();
	key_6->use_bold_font ();
	key_7->use_bold_font ();
	key_8->use_bold_font ();
	key_9->use_bold_font ();
	key_0->use_bold_font ();
	key_minus->use_bold_font ();
	key_equals->use_bold_font ();
	key_delete->use_bold_font ();
	key_backquote->use_bold_font ();
	key_shift1->use_bold_font ();
	key_shift2->use_bold_font ();
	key_control1->use_bold_font ();
	key_control2->use_bold_font ();
	key_tab->use_bold_font ();
	key_escape->use_bold_font ();
	key_enter->use_bold_font ();
	key_period->use_bold_font ();
	key_comma->use_bold_font ();
	key_slash->use_bold_font ();
	key_leftbracket->use_bold_font ();
	key_rightbracket->use_bold_font ();
	key_backslash->use_bold_font ();
	key_semicolon->use_bold_font ();
	key_quote->use_bold_font ();

	root_widget->bg = 0xe0e0e0;
}

Keyboard::Keyboard (void) 
{
	shift = control = false;

	root_widget = NULL;
	key_a = NULL;
	key_b = NULL;
	key_c = NULL;
	key_d = NULL;
	key_e = NULL;
	key_f = NULL;
	key_g = NULL;
	key_h = NULL;
	key_i = NULL;
	key_j = NULL;
	key_k = NULL;
	key_l = NULL;
	key_m = NULL;
	key_n = NULL;
	key_o = NULL;
	key_p = NULL;
	key_q = NULL;
	key_r = NULL;
	key_s = NULL;
	key_t = NULL;
	key_u = NULL;
	key_v = NULL;
	key_w = NULL;
	key_x = NULL;
	key_y = NULL;
	key_z = NULL;
	key_space = NULL;
	key_1 = NULL;
	key_2 = NULL;
	key_3 = NULL;
	key_4 = NULL;
	key_5 = NULL;
	key_6 = NULL;
	key_7 = NULL;
	key_8 = NULL;
	key_9 = NULL;
	key_0 = NULL;
	key_minus = NULL;
	key_equals = NULL;
	key_delete = NULL;
	key_backquote = NULL;
	key_shift1 = NULL;
	key_shift2 = NULL;
	key_control1 = NULL;
	key_control2 = NULL;
	key_tab = NULL;
	key_escape = NULL;
	key_enter = NULL;
	key_period = NULL;
	key_comma = NULL;
	key_slash = NULL;
	key_leftbracket = NULL;
	key_rightbracket = NULL;
	key_backslash = NULL;
	key_semicolon = NULL;
	key_quote = NULL;

	create_widgets ();
}

Keyboard::~Keyboard ()
{
	puts ("Deleting Keyboard object.");
}

void 
Keyboard::show ()
{
	app->present_keyboard (this, DEFAULT_KEYBOARD_HEIGHT);
}

void 
Keyboard::layout_widgets (void)
{
	// TO DO: Add support for non-qwerty layout.

	if (!root_widget)
		return;

	Rect r = root_widget->get_rect ();
	int available_width = app->dpy_width;
	int padding = 2;
	int bw = (available_width - 14*padding) / 13;
	int bh = (r.size.height - 6*padding)/5;
	
	int x = padding;
	int y = padding;

	// NOTE:
	// The keyboard is 13 keys across for the first 2 rows.
	// In landscape mode, if the screen is 7.7 inches wide (a 10 inch display)
	// each key will use 0.59 inches or 15 mm.
	// A standard full-size keyboard has 19mm key pitch. 
	// This can only be achieved if there are 10 keys horizontally 
	// in landscape mode (qwertyuiop = 10 keys), which would require
	// an additional row of keys.

	key_1->set_rect (Rect_new (x, y, bw, bh)); x += bw + padding;
	key_2->set_rect (Rect_new (x, y, bw, bh)); x += bw + padding;
	key_3->set_rect (Rect_new (x, y, bw, bh)); x += bw + padding;
	key_4->set_rect (Rect_new (x, y, bw, bh)); x += bw + padding;
	key_5->set_rect (Rect_new (x, y, bw, bh)); x += bw + padding;
	key_6->set_rect (Rect_new (x, y, bw, bh)); x += bw + padding;
	key_7->set_rect (Rect_new (x, y, bw, bh)); x += bw + padding;
	key_8->set_rect (Rect_new (x, y, bw, bh)); x += bw + padding;
	key_9->set_rect (Rect_new (x, y, bw, bh)); x += bw + padding;
	key_0->set_rect (Rect_new (x, y, bw, bh)); x += bw + padding;
	key_minus->set_rect (Rect_new (x, y, bw, bh)); x += bw + padding;
	key_equals->set_rect (Rect_new (x, y, bw, bh)); x += bw + padding;
	key_delete->set_rect (Rect_new (x, y, bw, bh)); x += bw + padding;

	y += bh + padding;
	x = padding;
	key_q->set_rect (Rect_new (x, y, bw, bh)); x += bw + padding;
	key_w->set_rect (Rect_new (x, y, bw, bh)); x += bw + padding;
	key_e->set_rect (Rect_new (x, y, bw, bh)); x += bw + padding;
	key_r->set_rect (Rect_new (x, y, bw, bh)); x += bw + padding;
	key_t->set_rect (Rect_new (x, y, bw, bh)); x += bw + padding;
	key_y->set_rect (Rect_new (x, y, bw, bh)); x += bw + padding;
	key_u->set_rect (Rect_new (x, y, bw, bh)); x += bw + padding;
	key_i->set_rect (Rect_new (x, y, bw, bh)); x += bw + padding;
	key_o->set_rect (Rect_new (x, y, bw, bh)); x += bw + padding;
	key_p->set_rect (Rect_new (x, y, bw, bh)); x += bw + padding;
	key_leftbracket->set_rect (Rect_new (x, y, bw, bh)); x += bw + padding;
	key_rightbracket->set_rect (Rect_new (x, y, bw, bh)); x += bw + padding;
	key_backslash->set_rect (Rect_new (x, y, bw, bh)); x += bw + padding;

	y += bh + padding;
	x = padding + bw/2;
	key_a->set_rect (Rect_new (x, y, bw, bh)); x += bw + padding;
	key_s->set_rect (Rect_new (x, y, bw, bh)); x += bw + padding;
	key_d->set_rect (Rect_new (x, y, bw, bh)); x += bw + padding;
	key_f->set_rect (Rect_new (x, y, bw, bh)); x += bw + padding;
	key_g->set_rect (Rect_new (x, y, bw, bh)); x += bw + padding;
	key_h->set_rect (Rect_new (x, y, bw, bh)); x += bw + padding;
	key_j->set_rect (Rect_new (x, y, bw, bh)); x += bw + padding;
	key_k->set_rect (Rect_new (x, y, bw, bh)); x += bw + padding;
	key_l->set_rect (Rect_new (x, y, bw, bh)); x += bw + padding;
	key_semicolon->set_rect (Rect_new (x, y, bw, bh)); x += bw + padding;
	key_quote->set_rect (Rect_new (x, y, bw, bh)); x += bw + padding;
	key_enter->set_rect (Rect_new (x, y, available_width - x - padding, bh)); x += bw + padding;

	y += bh + padding;
	x = padding;
	key_shift1->set_rect (Rect_new (x, y, bw, bh)); x += bw + padding;
	key_z->set_rect (Rect_new (x, y, bw, bh)); x += bw + padding;
	key_x->set_rect (Rect_new (x, y, bw, bh)); x += bw + padding;
	key_c->set_rect (Rect_new (x, y, bw, bh)); x += bw + padding;
	key_v->set_rect (Rect_new (x, y, bw, bh)); x += bw + padding;
	key_b->set_rect (Rect_new (x, y, bw, bh)); x += bw + padding;
	key_n->set_rect (Rect_new (x, y, bw, bh)); x += bw + padding;
	key_m->set_rect (Rect_new (x, y, bw, bh)); x += bw + padding;
	key_comma->set_rect (Rect_new (x, y, bw, bh)); x += bw + padding;
	key_period->set_rect (Rect_new (x, y, bw, bh)); x += bw + padding;
	key_slash->set_rect (Rect_new (x, y, bw, bh)); x += bw + padding;
	key_shift2->set_rect (Rect_new (x, y, available_width - x - padding, bh)); x += bw + padding;

	y += bh + padding;
	x = padding;
	key_control1->set_rect (Rect_new (x, y, bw, bh)); x += bw + padding;
	key_tab->set_rect (Rect_new (x, y, bw, bh)); x += bw + padding;
	key_escape->set_rect (Rect_new (x, y, bw, bh)); x += bw + padding;

	Dimension space_width = bw * 5;
	x = (available_width - space_width) /2.;
	key_space->set_rect (Rect_new (x, y, space_width, bh)); 

	x = available_width - padding - bw;
	key_control2->set_rect (Rect_new (x, y, bw, bh)); x -= bw + padding;
}

void 
Keyboard::will_appear (void)
{
}

void 
Keyboard::will_disappear (void)
{
}

void 
Keyboard::did_appear (void)
{
}

void 
Keyboard::did_disappear (void)
{
}

void 
Keyboard::receive_message (Object* sender, const char* message, MessageParameter param)
{
#if 0
	if (!delegate)
		return;
#endif

	Widget *focus_widget = app->get_key_focus_widget ();
	if (!focus_widget)
		return;

	bool was_on_screen_key = true;

	KeySym key = 0;
	if (!strcmp (message, KEY_UP) || !strcmp (message, KEY_DOWN)) { // KeySym originating from physical keyboard.
		was_on_screen_key = false;
		key = param;
	}
	else
	if (strcmp (message, TOUCH_UP_INSIDE)) 
		return;

	if (!key) {
		if (sender == key_a) key = XK_a;
		else if (sender == key_b) key = XK_b;
		else if (sender == key_c) key = XK_c;
		else if (sender == key_d) key = XK_d;
		else if (sender == key_e) key = XK_e;
		else if (sender == key_f) key = XK_f;
		else if (sender == key_g) key = XK_g;
		else if (sender == key_h) key = XK_h;
		else if (sender == key_i) key = XK_i;
		else if (sender == key_j) key = XK_j;
		else if (sender == key_k) key = XK_k;
		else if (sender == key_l) key = XK_l;
		else if (sender == key_m) key = XK_m;
		else if (sender == key_n) key = XK_n;
		else if (sender == key_o) key = XK_o;
		else if (sender == key_p) key = XK_p;
		else if (sender == key_q) key = XK_q;
		else if (sender == key_r) key = XK_r;
		else if (sender == key_s) key = XK_s;
		else if (sender == key_t) key = XK_t;
		else if (sender == key_u) key = XK_u;
		else if (sender == key_v) key = XK_v;
		else if (sender == key_w) key = XK_w;
		else if (sender == key_x) key = XK_x;
		else if (sender == key_y) key = XK_y;
		else if (sender == key_z) key = XK_z;
		else if (sender == key_0) key = XK_0;
		else if (sender == key_1) key = XK_1;
		else if (sender == key_2) key = XK_2;
		else if (sender == key_3) key = XK_3;
		else if (sender == key_4) key = XK_4;
		else if (sender == key_5) key = XK_5;
		else if (sender == key_6) key = XK_6;
		else if (sender == key_7) key = XK_7;
		else if (sender == key_8) key = XK_8;
		else if (sender == key_9) key = XK_9;
		else if (sender == key_minus) key = XK_minus;
		else if (sender == key_backslash) key = XK_backslash;
		else if (sender == key_equals) key = XK_equal;
		else if (sender == key_delete) key = XK_BackSpace;
		else if (sender == key_quote) key = '\'';
		else if (sender == key_period) key = XK_period;
		else if (sender == key_comma) key = XK_comma;
		else if (sender == key_slash) key = XK_slash;
		else if (sender == key_shift1 || sender == key_shift2) {
			// RULE: Tapping on the on-screen button toggles the selected state.
			shift = !shift;
			key_shift1->set_selected (shift);
			key_shift2->set_selected (shift);
			return;
		}
		else if (sender == key_control1 || sender == key_control2) {
			// RULE: Tapping on the on-screen button toggles the selected state.
			control = !control;
			key_control1->set_selected (control);
			key_control2->set_selected (control);
			return;
		}
		else if (sender == key_enter) key = XK_Return;
		else if (sender == key_escape) key = XK_Escape;
		else if (sender == key_backquote) key = XK_grave;
	}

	if (key == XK_Shift_L || key == XK_Shift_R) {
		if (!strcmp (message, KEY_DOWN)) {
			shift = true;
		} else {
			shift = false;
		}
		
		key_shift1->set_selected (shift);
		key_shift2->set_selected (shift);
		return;
	}
	if (key == XK_Control_L || key == XK_Control_R) {
		if (!strcmp (message, KEY_DOWN))
			control = true;
		else
			control = false;
		
		key_control1->set_selected (control);
		key_control2->set_selected (control);
		return;
	}

	if (!strcmp (message, KEY_UP))
		return; 

	if (shift) {
		key = get_shifted_keysym (key);
	}

	if (key >= XK_a && key <= XK_z && control) {
		key -= XK_a;
	}
	else if (key >= XK_A && key <= XK_Z && control) {
		key -= XK_A;
	}

	if (!key)
		return;
	
	app->convey_key_to_key_focus_widget (key, true);

	// RULE: Pressing an on-screen key other than shift or control
	// results in shift and control being cleared, but non-on-screen
	// keys do not clear them (to ensure that key repeat behavior works).

	if (was_on_screen_key) {
		if (shift) {	
			shift = false;
			key_shift1->set_selected (shift);
			key_shift2->set_selected (shift);
		}
		if (control) {	
			control = false;
			key_control1->set_selected (control);
			key_control2->set_selected (control);
		}
	}
}

