/*=========================================================================
 * This file is part of TouchWidgets, which is a widget library that
 * supports touch and animation.
 *
 * Copyright (C) 2004,2008-2010,2013 Zachary Smith, veritas@comcast.net.
 *
 * TouchWidgets is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * TouchWidgets is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with TouchWidgets.  If not, see <http://www.gnu.org/licenses/>.
 *=======================================================================*/

#ifndef _TOUCHWIDGETS_KEYBOARD_H
#define _TOUCHWIDGETS_KEYBOARD_H

#include <TouchWidgets/Controller.h>
#include <TouchWidgets/Button.h>
#include <TouchWidgets/Label.h>

using namespace TouchWidgets;

class Keyboard : public Controller
{
	Button *key_a;
	Button *key_b;
	Button *key_c;
	Button *key_d;
	Button *key_e;
	Button *key_f;
	Button *key_g;
	Button *key_h;
	Button *key_i;
	Button *key_j;
	Button *key_k;
	Button *key_l;
	Button *key_m;
	Button *key_n;
	Button *key_o;
	Button *key_p;
	Button *key_q;
	Button *key_r;
	Button *key_s;
	Button *key_t;
	Button *key_u;
	Button *key_v;
	Button *key_w;
	Button *key_x;
	Button *key_y;
	Button *key_z;
	Button *key_space;
	Button *key_1;
	Button *key_2;
	Button *key_3;
	Button *key_4;
	Button *key_5;
	Button *key_6;
	Button *key_7;
	Button *key_8;
	Button *key_9;
	Button *key_0;
	Button *key_minus;
	Button *key_equals;
	Button *key_delete;
	Button *key_backquote;
	Button *key_shift1;
	Button *key_shift2;
	Button *key_control1;
	Button *key_control2;
	Button *key_escape;
	Button *key_tab;
	Button *key_enter;
	Button *key_period;
	Button *key_comma;
	Button *key_slash;
	Button *key_leftbracket;
	Button *key_rightbracket;
	Button *key_backslash;
	Button *key_semicolon;
	Button *key_quote;

	// TO DO: Add Alt key for access to special characters.

	int keyboard_type;

	bool shift;
	bool control;

	void create_widgets (void);

public:
	Keyboard ();
	~Keyboard ();

	void show ();

        virtual const char* class_name () { return "Keyboard"; }

	void layout_widgets (void);
	void will_appear (void);
	void will_disappear (void);
	void did_appear (void);
	void did_disappear (void);

	void receive_message (Object*, const char*, MessageParameter); 
};

#endif
