/*=========================================================================
 * This file is part of TouchWidgets, which is a widget library that
 * supports touch and animation.
 *
 * Copyright (C) 2004,2008-2010,2013 Zachary Smith, veritas@comcast.net.
 *
 * TouchWidgets is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * TouchWidgets is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with TouchWidgets.  If not, see <http://www.gnu.org/licenses/>.
 *=======================================================================*/

#ifndef _TOUCHWIDGETS_LABEL_H
#define _TOUCHWIDGETS_LABEL_H

#include <TouchWidgets/Widget.h>

namespace TouchWidgets {

class Label : public Widget
{
	int align;
	const char *string;
        bool use_bold_default_font;

public:
	virtual void draw (Rect);

	void set_alignment (int align_) {
		align = align_;
		redraw ();
	}

	Label ();
	Label (const char *);
	virtual ~Label ();

        virtual const char* class_name () { return "Label"; }

        void use_bold_font (void) { use_bold_default_font = true; redraw (); }
};

}

#endif

