/*=========================================================================
 * This file is part of TouchWidgets, which is a widget library that
 * supports touch and animation.
 *
 * Copyright (C) 2004,2008-2010,2013 Zachary Smith, veritas@comcast.net.
 *
 * TouchWidgets is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * TouchWidgets is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with TouchWidgets.  If not, see <http://www.gnu.org/licenses/>.
 *=======================================================================*/


#include <TouchWidgets/Common.h>
#include <TouchWidgets/Object.h>
#include <TouchWidgets/App.h>

using namespace TouchWidgets;

Object::Object (void) 
{
	delegate = NULL;
	name = NULL;
	style_class = NULL;
}

Object::~Object (void)
{
}

void 
Object::receive_message (Object *sender, Message m, MessageParameter p)
{
	// NOTE: Only implemented in subclasses.
}

void 
Object::set_delegate (Object *d) 
{ 
	if (d) 
		delegate = d; 
#ifdef DEBUG_DELEGATES
	printf ("Setting delegate of %s to %lx\n",name,(unsigned long) delegate);
#endif
}

