/*=========================================================================
 * This file is part of TouchWidgets, which is a widget library that
 * supports touch and animation.
 *
 * Copyright (C) 2004,2008-2010,2013 Zachary Smith, veritas@comcast.net.
 *
 * TouchWidgets is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * TouchWidgets is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with TouchWidgets.  If not, see <http://www.gnu.org/licenses/>.
 *=======================================================================*/

#ifndef _TOUCHWIDGETS_PROGRESS_H
#define _TOUCHWIDGETS_PROGRESS_H

#include <TouchWidgets/Widget.h>

namespace TouchWidgets {

class Progress : public Widget
{
	int value;

public:
	void draw (Rect);

	void set_value (int);
	int get_value (void) { return value; }

	RGB fg_gradient1; // lighter than fg
	RGB fg_gradient2; // darker than fg

	Progress (void);
	~Progress (void);

        virtual const char* class_name () { return "Progress"; }
};

}

#endif

