/*=========================================================================
 * This file is part of TouchWidgets, which is a widget library that
 * supports touch and animation.
 *
 * Copyright (C) 2004,2008-2010,2013 Zachary Smith, veritas@comcast.net.
 *
 * TouchWidgets is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * TouchWidgets is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with TouchWidgets.  If not, see <http://www.gnu.org/licenses/>.
 *=======================================================================*/

#ifndef _TOUCHWIDGETS_UTIL_H
#define _TOUCHWIDGETS_UTIL_H

#include <X11/Xutil.h>

extern int get_visual_class (XVisualInfo *vinfo);

typedef struct 
{
        int dx, dy;
        int e;
        int j;
        int sum;
} 
BresenhamInfo;

extern void bresenham_init (BresenhamInfo *bi, int target_size, int original_size);
extern int bresenham_get_next (BresenhamInfo *bi);

#endif

